/* program za sjencanje fragmenata */
uniform sampler2D tex1;
uniform samplerCube cubeMap;

varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;

void main( void )
{
	vec3 n, halfV;
	float NdotL, NdotHV;
	vec4 color = ambient;
	
/* procesor fragmenata ne moe pisati u varying varijablu pa koristimo pomonu lokalnu varijablu u koju emo pohraniti normalizirani vektor normale */
	n = normalize(normal);
	
/* raunamo skalarni produkt vektora normale i vektora svjetla */
	NdotL = max(dot(n,lightDir),0.0);

	if (NdotL > 0.0) {
		halfV = normalize(halfVector);
		NdotHV = max(dot(n,halfV),0.0);
		color += diffuse * NdotL;
		color += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV,gl_FrontMaterial.shininess);		
	}

	// boja dobivena osvjetljenjem i osnovnom teksturom
	vec4 base_color = color* texture2D( tex1, gl_TexCoord[0].xy);
	// dohvacanje elementa teksture okoline
	vec4 cube_color = textureCube(cubeMap, gl_TexCoord[1].xyz);

	// konacna boja je kombinacija osnovne teksture i teksture okoline
	gl_FragColor = base_color + cube_color*0.4;
}