// matrica koja odreduje poloaj vrha u odnosu na svijet
//uniform mat4 ModelWorld4x4;
const mat4 ModelWorld4x4=mat4(	1.0, 0.0, 0.0, 0.0, 
				0.0, 1.0, 0.0, 0.0, 
				0.0, 0.0, 1.0, 0.0, 
				0.0, 0.0, 0.0, 1.0);

// pozicija pogleda u odnosu na svijet
uniform vec4 ViewPosition;

varying vec4 diffuse, ambient;
varying vec3 normal, lightDir, halfVector;

void main( void )
{
	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightDir = normalize(vec3(gl_LightSource[0].position));
	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
/* Raunamo neke komponente svjetla */
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;

	gl_Position = ftransform();

	// podmatrica za transformaciju normale
	mat3 ModelWorld3x3 = mat3( vec3( ModelWorld4x4[0]),vec3( ModelWorld4x4[1]),vec3( ModelWorld4x4[2]) );

	// pozicija u odnosu na okolinu
	vec4 WorldPos = ModelWorld4x4 * gl_Vertex;

	// normala u odnosu na svijet
	vec3 N = normalize( ModelWorld3x3 * gl_Normal );
	// vektor pogleda u odnosu na svijet
	vec3 Eye = normalize( WorldPos.xyz - ViewPosition.xyz );
	// vektor refleksije
	gl_TexCoord[1].xyz = reflect( Eye, N );
	gl_TexCoord[0] = gl_MultiTexCoord0;
}