/* Deklaracija globalnih varijabli */
varying vec4 diffuse, ambient;
varying vec3 normal, lightDir, halfVector;

void main()
{	
/* vektor normale se prvo mnoi sa matricom te se nakon toga postavlja na jedininu duljinu tj. normaliziramo */
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
/* Smjer iz kojeg dolazi svjetlo dobivamo normalizacijom vektora pozicije svjetla. */
	lightDir = normalize(vec3(gl_LightSource[0].position));

/* Normaliziramo polu-vektor */
	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
/* Raunamo neke komponente svjetla */
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;

/* na izlazu daje transformirani poloaj vrha */	
	gl_Position = ftransform();	
}
