/* program za sjencanje fragmenata */
varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;
uniform sampler2D tex1;
uniform sampler2D envMap;
const float reflection = 0.4; // faktor odbijanja

void main (void)
{
	vec3 n, halfV;
	float NdotL, NdotHV;
	vec4 color = ambient;
	
/* procesor fragmenata ne moe pisati u varying varijablu pa koristimo pomonu lokalnu varijablu u koju emo pohraniti normalizirani vektor normale */
	n = normalize(normal);
	
/* raunamo skalarni produkt vektora normale i vektora svjetla */
	NdotL = max(dot(n,lightDir),0.0);

	if (NdotL > 0.0) {
		halfV = normalize(halfVector);
		NdotHV = max(dot(n,halfV),0.0);
		color += diffuse * NdotL;
		color += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV,gl_FrontMaterial.shininess);		
	}

color = color*texture2D( tex1, gl_TexCoord[0].st);
vec4 env = texture2D( envMap, gl_TexCoord[1].st);
gl_FragColor = color + env*reflection;
}