/* program za sjencanje vrhova */
varying vec4 diffuse, ambient;
varying vec3 normal, lightDir, halfVector;

void main()
{
	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightDir = normalize(vec3(gl_LightSource[0].position));
	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
/* Raunamo neke komponente svjetla */
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;

gl_Position = ftransform();
gl_TexCoord[0] = gl_MultiTexCoord0;
vec3 U = normalize( vec3(gl_ModelViewMatrix * gl_Vertex) );
vec3 N = normalize( gl_NormalMatrix * gl_Normal );
vec3 R = reflect( U, N );
float m = 2.0 * sqrt( R.x*R.x + R.y*R.y + (R.z+1.0)*(R.z+1.0) );
gl_TexCoord[1].s = R.x/m + 0.5;
gl_TexCoord[1].t = R.y/m + 0.5;
}